#include "stm32f10x.h"
#include "STM32_init.h"
#include <stdio.h>

#include "stm32f10x_flash.h"



 
//------------------------------------------------------------------------------
 
void InitAll(void);
void STM32_Init (void);
void delay_ms(unsigned int);

unsigned char short_flag, clock_fail_flag, recieve_flag, overflow_flag;
unsigned char symbol;

unsigned char data_usart;

unsigned int time_delay_ms;

unsigned int data;

//------------------------------------------------------------------------------

unsigned char cnt_bit = 0;              //  
unsigned char code [14];                // 

unsigned int counter = 0;               //"" 

#define l_min    40                     //  "" (long)   ,  "" , 1,28..2,176 
#define l_max    68
#define s_min    22                     //  "" (short)   ,  "" , 0,704..1,088
#define s_max    34

unsigned char state = 0;                //   
unsigned char error_flag = 0;           // 

//  ,  14 
unsigned char startbit1 = 0;                    //  , .. = 1
unsigned char startbit2 = 0;                    //  , .. = 1                    
unsigned char toggle = 0;                       // ,      ,   -  .!
unsigned char address = 0;                      // , 5 
unsigned char command = 0;                      // (), 6 

//------------------------------------------------------------------------------
 
int main( void) 
	{
 	InitAll();

	printf ("STM32 On-line\r");

	while( 1) 
  		{
    	if (recieve_flag)
			{
			recieve_flag = 0;

			printf ("RC5.addr=%02x\r", address);
			printf ("RC5.cmd=%02x\r\r", command);

			GPIO_SetBits(GPIOC, GPIO_Pin_9);
			delay_ms(300);
			GPIO_ResetBits(GPIOC, GPIO_Pin_9);
			}

		if (overflow_flag)
			{
			overflow_flag = 0;
			printf ("Timer Overflow\r\r");
			}
		}
	}
 
//------------------------------------------------------------------------------

void GPIO_setup(void)
	{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
 	
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  	GPIO_Init( GPIOB, &GPIO_InitStructure); 
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
 	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  	GPIO_Init( GPIOC, &GPIO_InitStructure);
	}
 
void InitAll( void) 
	{
  	GPIO_setup();
	STM32_Init ();
	}
 
//------------------------------------------------------------------------------

void delay_ms(unsigned int Val) 
	{
  	time_delay_ms = Val;
	while (time_delay_ms) __NOP();
    }

void  SysTick_Handler (void)
	{
	if (time_delay_ms) time_delay_ms--;
	}

unsigned int msec5_cnt;
unsigned char led_bright_cnt;
unsigned char led_cnt;

void TIM2_IRQHandler (void)
	{
	if (TIM2->SR & TIM_SR_UIF)   
		{
		TIM2->SR &= ~TIM_SR_UIF;
		
		if (++msec5_cnt == 125)
			{
			msec5_cnt = 0;
			++led_bright_cnt; 
			}
		
		if (++led_cnt < led_bright_cnt) GPIO_ResetBits(GPIOC, GPIO_Pin_8);
			else GPIO_SetBits(GPIOC, GPIO_Pin_8);
		}
	}

int sendchar (int data)
	{
	uint32_t i = 5000;
	
	USART_SendData(USART1, data);
	while (--i) __NOP();
	return 0;
	}

void EXTI9_5_IRQHandler (void)
	{
	if (EXTI->PR & (1<<9)) //   EXTI9?
		{  
		EXTI->PR |= (1<<9); //    EXTI9.  
        short_flag = 1;    //   EXTI9
		
		TIM_Cmd(TIM4, DISABLE);
		counter = TIM_GetCounter(TIM4);						//  -
        TIM_SetCounter(TIM4, 0);                           // 
        TIM_Cmd(TIM4, ENABLE);
		error_flag = 1;                              //  -    ,   
               
        if (cnt_bit == 0)                       //    
                {
                TIM_Cmd(TIM4, ENABLE);           // ,  31250 (      )
                code [cnt_bit] = !(GPIO_ReadInputDataBit( GPIOB, GPIO_Pin_9));               //  , PIND.2 -  ,  0
                cnt_bit++;                              //   
                state = 1;                              // , ..  1
                }
                  
                else                                        //   (   )
                        {
                        if ((counter>s_min) && (counter<s_max)) //  
                                {
                                if (state)                      //  1
                                        {
                                        state = 0;              // 
                                        error_flag = 0;              // , ..  
                                        }
                                        else                    //  0
                                                {
                                                state = 1;                      // , ..  - 1
                                                code[cnt_bit] = !(GPIO_ReadInputDataBit( GPIOB, GPIO_Pin_9));        //  -  
                                                cnt_bit++;                      //  
                                                error_flag=0;                        // , ..  
                                                };
                                };     
                   
                        if ((counter>l_min) && (counter<l_max)) //  
                                {
                                code[cnt_bit] = !(GPIO_ReadInputDataBit( GPIOB, GPIO_Pin_9));        //  -  
                                cnt_bit++;                      //  
                                error_flag = 0;                      // , ..  
                                };
                                                  
                        if (error_flag == 1)                         //       ,  
                                {
                                char i = 0;                     // 
                                
								//TIM_SetCounter(TIM4, 0);        // 
                                TIM_Cmd(TIM4, DISABLE);  // 
                                TIM_SetCounter(TIM4, 0);        // 
                                counter = 0;                    // 
                                cnt_bit = 0;                    //   
                                for (i=0; i<14; i++) code[i]=0; //   
                                };
                   
                        if (cnt_bit == 14)                      //   14 
                                {
                                char i = 0;                     // 
                                //TIM_SetCounter(TIM4, 0);        // 
								TIM_Cmd(TIM4, DISABLE);  // 
                                TIM_SetCounter(TIM4, 0);                  // 
                                cnt_bit = 0;                    //   
                                
                                startbit1 = code[0];            //  
                                startbit2 = code[1];            //  
                                toggle = code[2];               //-
                                                                //    
                                address = (code[3] << 4)|(code[4] << 3)|(code[5] << 2)|(code[6] << 1)|code[7];                    
                                command = (code[8] << 5)|(code[9] << 4)|(code[10] << 3 )|(code[11] << 2)|(code[12] << 1)|code[13];
                                     
                                for (i=0; i<14; i++) code[i]=0; //   
								recieve_flag = 1;
                                };
                        };                                                                                
        };
	}


void TIM4_IRQHandler (void)
	{
	char i = 0;
	
	if (TIM4->SR & TIM_SR_UIF)   
		{
		TIM4->SR &= ~TIM_SR_UIF;
		
		
		TIM_Cmd(TIM4, DISABLE);
		TIM_SetCounter(TIM4, 0);

		counter = 0;                    // 
        cnt_bit = 0;                    //   
        for (i=0; i<14; i++) code[i]=0; //   

		overflow_flag = 1;
        }
	}
//------------------------------------------------------------------------------


